/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2011, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@member.fsf.org
-------------------------------------------------------------------------------*/
#ifndef BSP_H
#define BSP_H
#include <stm32f4xx.h>
#include <gpio.h>
#include <ili9328.h>
#include <genericLCD_Controler.h>
/*
#ifndef PD12
  #define PD12
#endif
#ifndef PD13
  #define PD13
#endif
*/
#define __MAX_OPENED_FILES__ 32
#define __FS_ROOT_SIZE__ 32

#define LED1 PD12
#define LED2 PD13

#define LCD_RESET PD10
#define LCD_BACKL PE11
#define LCD_RS    PE4
#define LCD_CS    PD7


#define GPIOGETPORT(gpio)   ((GPIO_TypeDef*)(((((uint32_t)gpio) & (uint32_t)0x0000FF00)*(uint32_t)4) + (uint32_t)GPIOA))
#define GPIOPORTNUM(gpio)   (((uint32_t)(gpio) & (uint32_t)0x0000FF00)>>(uint32_t)8)


extern float VREF0;
extern LCD_t lcd0;
extern uint32_t OSC0;
extern uint32_t currentCpuFreq;



extern int bsp_init();

extern void bsp_GPIO_init();
extern void bsp_uart_init();
extern void bsp_iic_init();
extern void bsp_spi_init();
extern void bsp_SD_init();
extern int bsp_FSMC_init();

/*  VS1053  */
extern void clearXCS();
extern void setXCS();
extern int vs10XXDREQ();

/*   SD CARD */
void bsppowersdcard(char onoff);
char bspsdcardpresent();
void bspsdcardselect(char YESNO);
char bspsdcardwriteprotected();

void bsp_lcd0_write_reg(uint32_t reg,uint32_t data);
uint32_t bsp_lcd0_read_reg(uint32_t reg);
void bsp_lcd0_writeGRAM(void *buffer, uint32_t count);
void bsp_lcd0_readGRAM(void *buffer, uint32_t count);


#endif



















